SystemOrganization addCategory: #'Pier-Jetsam-Action'!

!PRContentsWidget methodsFor: '*pier-jetsam-action-override' stamp: 'kph 11/30/2007 19:01'!
buildComponent: aContext
	^ aContext command asComponent
		onAnswer: [ :value | self onAnswerCommand: (aContext command onReturn: value) ];
		yourself! !

PRCommand subclass: #PRAction
	instanceVariableNames: 'model isViewThenEdit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Action'!

!PRAction commentStamp: 'kph 11/30/2007 21:12' prior: 0!
A command which has a model of its own!

!PRAction class methodsFor: 'as yet unclassified' stamp: 'kph 2/4/2008 15:02'!
isValidIn: aContext

	"this is a valid command if the user is logged in"
	
	^ aContext user notNil! !

!PRAction class methodsFor: 'as yet unclassified' stamp: 'kph 10/22/2007 17:41'!
isVisibleInList
	^ false! !

!PRAction class methodsFor: 'as yet unclassified' stamp: 'kph 12/17/2007 13:48'!
model: aModel 

	^ self basicNew model: aModel; initialize; yourself! !

!PRAction methodsFor: 'as yet unclassified' stamp: 'kph 3/23/2009 01:26'!
asComponent
	   
	| component |
	component := self model asComponent.
	
	isViewThenEdit
		ifFalse: [
			component addValidatedForm.
			]
		ifTrue: [
			component addValidation; addSwitch.
			].
		
	^ component
 ! !

!PRAction methodsFor: 'as yet unclassified' stamp: 'kph 3/23/2009 01:24'!
beViewThenEdit

	isViewThenEdit := true! !

!PRAction methodsFor: 'as yet unclassified' stamp: 'kph 11/30/2007 21:14'!
doExecute
	
   	self answer: (self context  command: PRViewCommand new)
		! !

!PRAction methodsFor: 'as yet unclassified' stamp: 'kph 11/30/2007 21:11'!
doValidate
	super doValidate.
	self model validate.! !

!PRAction methodsFor: 'as yet unclassified' stamp: 'kph 11/30/2007 21:17'!
getModel
	^ self subclassResponsibility! !

!PRAction methodsFor: 'as yet unclassified' stamp: 'kph 3/23/2009 01:24'!
initialize

	super initialize.
	
	isViewThenEdit := false! !

!PRAction methodsFor: 'as yet unclassified' stamp: 'kph 3/23/2009 01:20'!
isLogged
	^ false! !

!PRAction methodsFor: 'accessing' stamp: 'kph 11/30/2007 21:17'!
model
	^ model ifNil: [ model := self getModel ]! !

!PRAction methodsFor: 'accessing' stamp: 'kph 11/30/2007 21:10'!
model: anObject
	"Set the value of model"

	model := anObject! !

!PRAction methodsFor: 'as yet unclassified' stamp: 'kph 11/30/2007 21:15'!
onReturn: componentReturnValue  
	componentReturnValue ifNil: [ ^ nil ].
	
	model := componentReturnValue.	
	
	^ self	
 ! !

PRAction subclass: #PRViewToEditCommand
	instanceVariableNames: 'isEditMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Action'!

!PRViewToEditCommand class methodsFor: 'sql' stamp: 'kph 8/19/2007 15:16'!
filterNone: items

	^ items! !

!PRViewToEditCommand class methodsFor: 'as yet unclassified' stamp: 'kph 11/30/2007 19:53'!
label
	^ 'Your Account'! !

!PRViewToEditCommand class methodsFor: 'as yet unclassified' stamp: 'kph 8/15/2007 03:18'!
titleType
	^ 'View'! !

!PRViewToEditCommand methodsFor: 'as yet unclassified' stamp: 'kph 3/23/2009 01:18'!
asComponent
	   
	^ (self model description asComponentOn: self model)
			addValidation;
			addSwitch;
			yourself
 ! !

!PRCommand methodsFor: '*pier-jetsam-action' stamp: 'kph 11/30/2007 18:59'!
onReturn: aComponentReturnValue

	^ aComponentReturnValue! !
